/*
 * Mex - a media explorer
 *
 * Copyright © 2010, 2011 Intel Corporation.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU Lesser General Public License,
 * version 2.1, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses>
 */


#ifndef __MEX_COLUMN_H__
#define __MEX_COLUMN_H__

#include <mx/mx.h>
#include <mex/mex-utils.h>

G_BEGIN_DECLS

#define MEX_TYPE_COLUMN                                                 \
   (mex_column_get_type())
#define MEX_COLUMN(obj)                                                 \
   (G_TYPE_CHECK_INSTANCE_CAST ((obj),                                  \
                                MEX_TYPE_COLUMN,                        \
                                MexColumn))
#define MEX_COLUMN_CLASS(klass)                                         \
   (G_TYPE_CHECK_CLASS_CAST ((klass),                                   \
                             MEX_TYPE_COLUMN,                           \
                             MexColumnClass))
#define MEX_IS_COLUMN(obj)                                              \
   (G_TYPE_CHECK_INSTANCE_TYPE ((obj),                                  \
                                MEX_TYPE_COLUMN))
#define MEX_IS_COLUMN_CLASS(klass)                                      \
   (G_TYPE_CHECK_CLASS_TYPE ((klass),                                   \
                             MEX_TYPE_COLUMN))
#define MEX_COLUMN_GET_CLASS(obj)                                       \
   (G_TYPE_INSTANCE_GET_CLASS ((obj),                                   \
                               MEX_TYPE_COLUMN,                         \
                               MexColumnClass))

typedef struct _MexColumnPrivate MexColumnPrivate;
typedef struct _MexColumn      MexColumn;
typedef struct _MexColumnClass MexColumnClass;

struct _MexColumn
{
  MxWidget parent;

  MexColumnPrivate *priv;
};

struct _MexColumnClass
{
  MxWidgetClass parent_class;

  /* signals */
  void (* activated) (MexColumn *self);
};

GType mex_column_get_type (void) G_GNUC_CONST;
ClutterActor *mex_column_new (void);

gboolean mex_column_is_empty (MexColumn *column);

void     mex_column_set_collapse_on_focus (MexColumn *column,
                                           gboolean   collapse);
gboolean mex_column_get_collapse_on_focus (MexColumn *column);

void     mex_column_set_focus (MexColumn *column, gboolean focus);

gboolean mex_column_get_opened (MexColumn *column);

void      mex_column_set_model (MexColumn *column, MexModel *model);
MexModel* mex_column_get_model (MexColumn *column);

void      mex_column_set_child_opacity (MexColumn *column, guchar opacity);

G_END_DECLS

#endif /* __MEX_COLUMN_H__ */
